<template>
  <v-layout>
    <v-flex>
      <template v-if="task.rating === null">
        <v-stepper v-model="e6" vertical>
          <v-stepper-step :complete="e6 > 1" step="1">
            Жалоба - {{task.name}}
            <small>Описание жалобы</small>
          </v-stepper-step>

          <v-stepper-content step="1">
            <h2>Суть обращения</h2>
            <div>
              {{task.description}}
            </div>
            <table class="operatorDetailTable text-xs-left mt-4 " width="100%">
              <tr>
                <td style="width: 60%">Подана</td>
                <td style="width: 40%; text-align: right;">
                  {{timestampToDateTime(task.createdAt)}}
                </td>
              </tr>
              <tr>
                <td style="width: 60%">Местоположение</td>
                <td style="width: 40%; text-align: right;"><a href="">Нижний
                  Новгород,
                  улица Нестерова</a></td>
              </tr>
              <tr>
                <td style="width: 60%">Голосов</td>
                <td style="width: 40%; text-align: right;">
                  {{task.followerList.length}}
                </td>
              </tr>
            </table>
            <v-btn color="primary" @click="e6 = 2">Далее</v-btn>
          </v-stepper-content>

          <v-stepper-step :complete="e6 > 2" step="2">Загрузите фото
          </v-stepper-step>

          <v-stepper-content step="2">

            <v-layout row wrap>
              <v-flex sm2 class="mr-4"
                      v-for="(item, index) in task.images" :key="index">
                <v-card flat tile class="d-flex scanImg">
                  <v-img
                    :src="item"
                    :lazy-src="item"
                    aspect-ratio="1"
                    class="grey lighten-2"
                  >
                    <v-icon class="deleteImg" @click="deleteImage(index)">
                      delete
                    </v-icon>
                  </v-img>
                </v-card>
              </v-flex>
              <v-flex sm2>
                <label class="downloadAvatar d-flex">
                  <v-icon large class="downloadAvatarIcon mr-3">add</v-icon>
                  <input @change="addImage($event.target.files)" ref="file"
                         type="file" style="visibility: hidden; height: 0; ">
                </label>
              </v-flex>
            </v-layout>

            <v-btn color="primary" @click="e6 = 3">Далее</v-btn>
            <v-btn flat @click="e6 = 2">Вернуться</v-btn>
          </v-stepper-content>

          <v-stepper-step :complete="e6 > 3" step="3">Поставьте оценку задаче
          </v-stepper-step>
          <v-stepper-content step="3">
            <v-rating
              v-model="rating"
              size="4"
              length="4"
              background-color="red lighten-3"
              color="orange"
              x-large
            ></v-rating>
            <v-btn color="success" @click="estimateTask">
              Оценить
            </v-btn>
            <v-btn flat @click="e6 = 2">Вернуться</v-btn>
          </v-stepper-content>
        </v-stepper>
      </template>
      <template v-else>
        <v-flex>
          <h3>Оценка работ</h3>
          <v-layout wrap>
            <v-flex sm2 class="mr-4"
                    v-for="(item, index) in task.images" :key="index">
              <v-card flat tile class="d-flex scanImg">
                <v-img
                  :src="item"
                  :lazy-src="item"
                  aspect-ratio="1"
                  class="grey lighten-2"
                >
                </v-img>
              </v-card>
            </v-flex>
          </v-layout>
          <div class="text-xs-center">
            <h2>Оценка исполнения {{task.rating}} звезды</h2>
            <h1>Спасибо за оценку!</h1>
          </div>
        </v-flex>
      </template>

      <v-btn @click="backTo()" color="secondary">
        <v-icon>keyboard_arrow_left</v-icon>
        Вернуться
      </v-btn>
    </v-flex>
  </v-layout>
</template>

<script>
  import BaseButton from '@/components/base/Button'
  import moment from 'moment'
  import { mapGetters } from 'vuex'

  /**
   * @name ViewTask
   * @mixes Vue
   */
  export default {
    components: { BaseButton },
    props: ['id'],
    name: 'ViewTask',
    data: () => ({
      rating: 1,
      e6: 1,
      task: {
        images: [],
        id: '0001',
        followerList: [],
        status: 'draft',
        creator: {}
      }
    }),
    computed: {
      ...mapGetters(['user'])
    },
    methods: {
      addImage (file) {
        const image = file[0];
        const reader = new FileReader();
        reader.readAsDataURL(image);
        reader.onloadend = () => {
          this.task.images.push(reader.result);
        };
      },
      deleteImage (index) {
        this.task.images.splice(index, 1);
      },
      backTo () {
        window.history.back();
      },
      timestampToDateTime (timestamp) {
        if (timestamp !== undefined) {
          return moment.unix(timestamp).format('hh:mm DD.MM.YYYY')
        }
      },
      estimateTask () {
        this.$store.dispatch('estimateTask', {
          id: this.task.id,
          rate: this.rating
        }).then(() => {
          this.task.rating = this.rating
        })
      }
    },
    async mounted () {
      let taskId = this.$route.params.id;
      if (taskId !== undefined) {
        let foundTask = this.$store.getters.taskId(taskId);
        if (foundTask !== undefined) {
          this.task = foundTask
        } else {
          this.$store.dispatch('getTaskById', taskId).then(task => {
            this.task = task
          })
        }
      }
    }
  }
</script>
